#!/sbin/sh

#Build config file
CONFIGFILE="/tmp/init.elementalx.rc"
BACKUP="/sdcard/.elementalx.backup"

echo "on boot" >> $CONFIGFILE
echo "" >> $CONFIGFILE

# KSM options
echo "write /sys/kernel/mm/ksm/sleep_millisecs 1000" >> $CONFIGFILE
echo "write /sys/kernel/mm/ksm/pages_to_scan 256" >> $CONFIGFILE
echo "write /sys/kernel/mm/ksm/deferred_timer 1" >> $CONFIGFILE
echo "write /sys/kernel/mm/ksm/run 1" >> $CONFIGFILE
echo "" >> $CONFIGFILE

#S2W
SR=`grep "item.1.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
SL=`grep "item.1.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
SU=`grep "item.1.3" /tmp/aroma/gest.prop | cut -d '=' -f2`
SD=`grep "item.1.4" /tmp/aroma/gest.prop | cut -d '=' -f2`

if [ $SL = 1 ]; then
  SL=2
fi
if [ $SU == 1 ]; then
  SU=4
fi
if [ $SD == 1 ]; then
  SD=8
fi  

S2W=$(( SL + SR + SU + SD ))
echo "write /sys/android_touch/sweep2wake " $S2W >> $CONFIGFILE

#DT2W
DT2W=`grep "item.1.5" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo "write /sys/android_touch/doubletap2wake " $DT2W >> $CONFIGFILE

#Camera launch gestures
CAMGEST=`grep "item.2.3" /tmp/aroma/gest.prop | cut -d '=' -f2`
echo "write /sys/android_touch/camera_gesture " $CAMGEST >> $CONFIGFILE

#S2S
S2S=`grep selected.0 /tmp/aroma/s2s.prop | cut -d '=' -f2`
if [ $S2S = 2 ]; then
  echo "write /sys/android_touch/sweep2sleep 1" >> $CONFIGFILE
elif [ $S2S = 3 ]; then
  echo "write /sys/android_touch/sweep2sleep 2" >> $CONFIGFILE
elif [ $S2S = 4 ]; then
  echo "write /sys/android_touch/sweep2sleep 3" >> $CONFIGFILE
else
  echo "write /sys/android_touch/sweep2sleep 0" >> $CONFIGFILE
fi

#WG vibration strength
VIBSTRENGTH=`grep "item.2.1" /tmp/aroma/gest.prop | cut -d '=' -f2`
if [ $VIBSTRENGTH = 0 ]; then
  echo "write /sys/android_touch/vib_strength 0" >> $CONFIGFILE
fi

#S2W/DT2W Power key toggle
PWR_KEY=`grep "item.2.2" /tmp/aroma/gest.prop | cut -d '=' -f2`
if [ $PWR_KEY = 1 ]; then
  echo "write /sys/module/qpnp_power_on/parameters/pwrkey_suspend 1" >> $CONFIGFILE
fi

#S2W/DT2W Timeout
if [ ! -e /tmp/aroma/timeout.prop ]; then
  echo "selected.0=1" > /tmp/aroma/timeout.prop;
fi

TIMEOUT=`cat /tmp/aroma/timeout.prop | cut -d '=' -f2`
if [ $TIMEOUT = 1 ]; then
  echo "write /sys/android_touch/wake_timeout 0" >> $CONFIGFILE
elif [ $TIMEOUT = 2 ]; then
  echo "write /sys/android_touch/wake_timeout 5" >> $CONFIGFILE
elif [ $TIMEOUT = 3 ]; then
  echo "write /sys/android_touch/wake_timeout 15" >> $CONFIGFILE
elif [ $TIMEOUT = 4 ]; then
  echo "write /sys/android_touch/wake_timeout 30" >> $CONFIGFILE
elif [ $TIMEOUT = 5 ]; then
  echo "write /sys/android_touch/wake_timeout 60" >> $CONFIGFILE
elif [ $TIMEOUT = 6 ]; then
  echo "write /sys/android_touch/wake_timeout 90" >> $CONFIGFILE
elif [ $TIMEOUT = 7 ]; then
  echo "write /sys/android_touch/wake_timeout 120" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#fsync
FSYNC=`grep "item.0.1" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $FSYNC = 1 ]; then
  echo "write /sys/module/sync/parameters/fsync_enabled 0" >> $CONFIGFILE
fi

#backlight dimmer
BLDIM=`grep "item.0.2" /tmp/aroma/mods.prop | cut -d '=' -f2`
if [ $BLDIM = 1 ]; then
  echo "write /sys/module/mdss_fb/parameters/backlight_dimmer 1" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

echo "on property:sys.boot_completed=1" >> $CONFIGFILE
echo "" >> $CONFIGFILE

#i/o scheduler
SCHED=`grep selected.1 /tmp/aroma/disk.prop | cut -d '=' -f2`
if [ $SCHED = 1 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler cfq"  >> $CONFIGFILE
elif [ $SCHED = 2 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler row"  >> $CONFIGFILE
elif [ $SCHED = 3 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler deadline"  >> $CONFIGFILE
elif [ $SCHED = 4 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler fiops"  >> $CONFIGFILE
elif [ $SCHED = 5 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler sio"  >> $CONFIGFILE
elif [ $SCHED = 6 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler bfq"  >> $CONFIGFILE
elif [ $SCHED = 7 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler noop"  >> $CONFIGFILE
elif [ $SCHED = 8 ]; then
  echo "write /sys/block/mmcblk0/queue/scheduler zen"  >> $CONFIGFILE
fi

#Readahead buffer size
READAHEAD=`grep selected.2 /tmp/aroma/disk.prop | cut -d '=' -f2`
if [ $READAHEAD = 1 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 128" >> $CONFIGFILE
elif [ $READAHEAD = 2 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 256" >> $CONFIGFILE
elif [ $READAHEAD = 3 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 512" >> $CONFIGFILE
elif [ $READAHEAD = 4 ]; then
  echo "write /sys/block/mmcblk0/queue/read_ahead_kb 1024" >> $CONFIGFILE
fi
echo "" >> $CONFIGFILE

#reinstall options
echo -e "##### Reinstall Options #####" > $BACKUP
echo -e "# These settings are only applied if you run the express installer" >> $BACKUP

#Maximum CPU freqs
CPU0=$(cat /tmp/aroma/cpu53.prop | cut -d '=' -f2)

echo -e "\n\n##### Max A53 CPU Frequncy #####" >> $BACKUP
echo -e "# 1=1632MHz 2=1536MHz" >> $BACKUP
echo -e "# 3=1440MHz 4=1248MHz" >> $BACKUP
echo -e "# 5=960MHz\n" >> $BACKUP

echo "CPU0=$CPU0" >> $BACKUP;

CPU4=$(cat /tmp/aroma/cpu57.prop | cut -d '=' -f2)

echo -e "\n\n##### Max A57 CPU Frequncy #####" >> $BACKUP
echo -e "# 1=2016MHz 2=1958MHz" >> $BACKUP
echo -e "# 3=1824MHz 4=1690MHz" >> $BACKUP
echo -e "# 5=1536MHz 6=1440MHz" >> $BACKUP
echo -e "# 7=1284MHz\n" >> $BACKUP

echo "CPU4=$CPU4" >> $BACKUP;

